/* ================================================================================== */
/* Copyright (c) 1998-1999 3Com Corporation or its subsidiaries. All rights reserved. */
/* ================================================================================== */

#ifndef _LOADAPPLICATION_H_
#define _LOADAPPLICATION_H_

#include "Platform_Files.h"		// FileHandle

struct LoadFilePB
{
	LoadFilePB (void) :
		appFile (),
		cardNo (0),
		dbID (0)
	{}

	LoadFilePB (const FileReference& fh) :
		appFile (fh),
		cardNo (0),
		dbID (0)
	{}

	FileReference	appFile;
	UInt			cardNo;
	LocalID			dbID;

	// B.S. operators for VC++ so that we can put objects of
	// this class into STL collections.

	bool operator < (const LoadFilePB& other) const
	{ return this < &other; }

	bool operator > (const LoadFilePB& other) const
	{ return this > &other; }

	bool operator == (const LoadFilePB& other) const
	{ return this == &other; }

	bool operator != (const LoadFilePB& other) const
	{ return this != &other; }
};


typedef vector<LoadFilePB>	LoadableList;

void	LoadPalmFile (FileHandle& applicationFile, UInt cardNo, LocalID& dbID);
void	LoadPalmFileList (LoadableList& fileList);
void	SavePalmFile (FileHandle& applicationFile, UInt cardNo, const char* databaseName);

#endif /* _LOADAPPLICATION_H_ */
  
  
